#!/bin/sh
export PATH='/usr/local/sbin:/usr/local/bin:/usr/bin:/usr/bin/site_perl:/usr/bin/vendor_perl:/usr/bin/core_perl:/usr/bin/site_perl:/usr/bin/vendor_perl:/usr/bin/core_perl:/usr/bin/site_perl:/usr/bin/vendor_perl:/usr/bin/core_perl:/usr/bin/site_perl:/usr/bin/vendor_perl:/usr/bin/core_perl'
echo 'name:                 binary-tagged
version:              0.2
visibility:           public
id:                   binary-tagged-0.2-4djPVC0fkW2HVkXlg8gq62
key:                  binary-tagged-0.2-4djPVC0fkW2HVkXlg8gq62
license:              BSD-3-Clause
maintainer:           Oleg Grenrus <oleg.grenrus@iki.fi>
author:               Oleg Grenrus <oleg.grenrus@iki.fi>
homepage:             https://github.com/phadej/binary-tagged#readme
synopsis:             Tagged binary serialisation.
description:
    Structurally tag binary serialisation stream.

    Say you have:

    @
    data Record = Record
    \  { _recordFields  :: HM.HashMap Text (Integer, ByteString)
    \  , _recordEnabled :: Bool
    \  }
    \  deriving (Eq, Show, Generic)

    instance Binary Record
    instance HasStructuralInfo Record
    instance HasSemanticVersion Record
    @

    then you can serialise and deserialise @Record@ values with a structure tag by simply

    @
    encodeTaggedFile "cachefile" record
    decodeTaggedFile "cachefile" :: IO Record
    @

    If structure of @Record@ changes in between, deserialisation will fail early.

    The overhead is next to non-observable, see [a simple benchmark](https://github.com/phadej/binary-tagged/blob/master/bench/Bench.hs).

    @
    benchmarking encode/Binary
    time                 362.6 μs   (361.2 μs .. 363.8 μs)

    benchmarking encode/Tagged
    time                 379.2 μs   (375.5 μs .. 382.2 μs)

    benchmarking decode/Binary
    time                 366.3 μs   (365.1 μs .. 368.1 μs)

    benchmarking decode/Tagged
    time                 367.6 μs   (367.0 μs .. 368.2 μs)
    @

category:             Data
abi:                  fc911cf68c3c3ad696ab2f73f648e5de
exposed:              True
exposed-modules:      Data.Binary.Tagged
import-dirs:          /usr/lib/ghc-8.10.1/site-local/binary-tagged-0.2
library-dirs:         /usr/lib/ghc-8.10.1/site-local/binary-tagged-0.2
dynamic-library-dirs: /usr/lib
data-dir:             /usr/share/x86_64-linux-ghc-8.10.1/binary-tagged-0.2
hs-libraries:         HSbinary-tagged-0.2-4djPVC0fkW2HVkXlg8gq62
depends:
    aeson-1.4.7.1-ANEJrhOqgvGIzgMZodlboL array-0.5.4.0 base-4.14.0.0
    base16-bytestring-0.1.1.6-DS9xLNC5hoWBUNdBXU0AGB binary-0.8.8.0
    bytestring-0.10.10.0 containers-0.6.2.1
    cryptohash-sha1-0.11.100.1-2gd8W0MJmDXLF2SYBClUB
    generics-sop-0.5.1.0-11ffLTzZqRz8rwTPB1uwcA
    hashable-1.3.0.0-EAzOv9XkxZx208nV7jdDUC
    scientific-0.3.6.2-BtzHiI4gx0yCagEKMn6y95
    tagged-0.8.6-6GC8EUw1ctH7ZAzzvpqZ7j text-1.2.3.2 time-1.9.3
    unordered-containers-0.2.10.0-91W4S6Yfdzi8lLtBcprU0Q
    vector-0.12.1.2-2820kU4E8Rq2FpOG9Xf2aE

haddock-interfaces:
    /usr/share/doc/haskell-binary-tagged/html/binary-tagged.haddock

haddock-html:         /usr/share/doc/haskell-binary-tagged/html
' | '/usr/bin/ghc-pkg' 'update' '--force' '-' '--global' '--no-user-package-db' "$@"

